with Ada.Sequential_IO;
with Interfaces; use Interfaces;

package Shardware is

  type Byte is mod 256;
  package Bin_IO is new Ada.Sequential_IO (Byte);
  type ByteArr is array (Integer range <>) of Byte;

  type BitArr is array (Integer range <>) of Boolean;

  type RegArrI is array (Integer range <>) of Integer;
  type RegArrF is array (Integer range <>) of Float;
  type RegArrU is array (Integer range <>) of Unsigned_32;

  function TempBytes (Instruction : ByteArr) return ByteArr;

  function UnToSignedInt (Value : Unsigned_32) return Integer;

  function BytesToBits (TheBytes : ByteArr) return BitArr;
  function BitsToBytes (BinNumber : BitArr) return ByteArr;

  function MyShiftU (Value : Byte; Amount : Integer) return Unsigned_32;

  function BytesToI (TheBytes : ByteArr) return Integer;
  function BytesToF (TheBytes : ByteArr) return Float;
  function BytesToU (TheBytes : ByteArr) return Unsigned_32;

  procedure MovI (Register : in out Integer; Value : Integer);
  procedure AddI (Register : in out Integer; Value : Integer);
  procedure MovF (Register : in out Float; Value : Float);
  procedure AddF (Register : in out Float; Value : Float);
  procedure MovU (Register : in out Unsigned_32; Value : Unsigned_32);
  procedure AddU (Register : in out Unsigned_32; Value : Unsigned_32);

end Shardware;
